# Copyright (c) 2000-2011, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define gcj_support %{?_with_gcj_support:1}%{!?_with_gcj_support:%{?_without_gcj_support:0}%{!?_without_gcj_support:%{?_gcj_support:%{_gcj_support}}%{!?_gcj_support:0}}}

%{expand: %%define pyver %(python -c 'import sys;print(sys.version[0:3])')}

%define cpython_version 2.4
%define cpythondir      python%{cpython_version}
%define pyxml_version   0.8.3
%define namedversion    2.5.0
%define section         free

Name:           jython
Version:        2.5.0
Release:        1%{?dist}
Epoch:          0
Summary:        Java source interpreter
License:        Modified CNRI Open Source License
URL:            http://www.jython.org/
Source0:        jython-2.5.0.tgz
# svn export http://jython.svn.sourceforge.net/svnroot/jython/tags/Release_2_5_0/jython/ jython-2.5.0
Source1:        jython-2.5.0.pom

Requires:  jpackage-utils >= 0:1.7.5
Requires:  java >= 0:1.6.0
Requires:  antlr
Requires:  antlr3
Requires:  constantine
Requires:  cpptasks
Requires:  jarjar
Requires:  jline
Requires:  jna
Requires:  jna-posix
Requires:  junit
Requires:  libreadline-java
Requires:  mysql-connector-java
Requires:  objectweb-asm
Requires:  servlet_2_5_api
Requires:  stringtemplate
Requires:  xerces-j2

BuildRequires:  java-devel >= 0:1.6.0
BuildRequires:  ant17 >= 0:1.7
BuildRequires:  mysql-connector-java
BuildRequires:  postgresql-jdbc
BuildRequires:  python >= 0:%{cpython_version}
BuildRequires:  PyXML >= 0:%{pyxml_version}
BuildRequires:  antlr
BuildRequires:  antlr3
BuildRequires:  constantine
BuildRequires:  cpptasks
BuildRequires:  ht2html
BuildRequires:  jarjar
BuildRequires:  jline
BuildRequires:  jna
BuildRequires:  jna-posix
BuildRequires:  junit
BuildRequires:  libreadline-java
BuildRequires:  objectweb-asm
BuildRequires:  servlet_2_5_api
BuildRequires:  stringtemplate
BuildRequires:  xerces-j2

Group:          Development/Java

Requires(post):    jpackage-utils >= 0:1.7.5
Requires(postun):  jpackage-utils >= 0:1.7.5
%if ! %{gcj_support}
BuildArch:      noarch
%endif
Buildroot:      %{_tmppath}/%{name}-%{version}-buildroot
%if %{gcj_support}
BuildRequires:    gnu-crypto
BuildRequires:    java-gcj-compat-devel
Requires(post):   java-gcj-compat
Requires(postun): java-gcj-compat
%endif

%description
Jython is an implementation of the high-level, dynamic, object-oriented
language Python seamlessly integrated with the Java platform. The
predecessor to Jython, JPython, is certified as 100% Pure Java. Jython is
freely available for both commercial and non-commercial use and is
distributed with source code. Jython is complementary to Java and is
especially suited for the following tasks: Embedded scripting - Java
programmers can add the Jython libraries to their system to allow end
users to write simple or complicated scripts that add functionality to the
application. Interactive experimentation - Jython provides an interactive
interpreter that can be used to interact with Java packages or with
running Java applications. This allows programmers to experiment and debug
any Java system using Jython. Rapid application development - Python
programs are typically 2-10X shorter than the equivalent Java program.
This translates directly to increased programmer productivity. The
seamless interaction between Python and Java allows developers to freely
mix the two languages both during development and in shipping products.

%package manual
Summary:        Manual for %{name}
Group:          Development/Java

%description manual
Documentation for %{name}.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Java

%description javadoc
%{summary}.

%package demo
Summary:        Demo for %{name}
Requires:       %{name} = %{epoch}:%{version}-%{release}
Group:          Development/Java

%description demo
Demonstrations and samples for %{name}.

%prep
%setup -q 
# remove all binary libs
for j in $(find . -name "*.jar"); do
    mv $j $j.no
done
# extlibs/antlr-2.7.7.jar.no
ln -s $(build-classpath antlr) extlibs/antlr-2.7.7.jar
# extlibs/antlr-3.1.2.jar.no
ln -s $(build-classpath antlr3) extlibs/antlr-3.1.2.jar
# extlibs/antlr-runtime-3.1.2.jar.no
ln -s $(build-classpath antlr3-runtime) extlibs/antlr-runtime-3.1.2.jar
# extlibs/asm-3.1.jar.no
ln -s $(build-classpath objectweb-asm/asm) extlibs/asm-3.1.jar
# extlibs/asm-commons-3.1.jar.no
ln -s $(build-classpath objectweb-asm/asm-commons) extlibs/asm-commons-3.1.jar
# extlibs/asm-util-3.1.jar.no
ln -s $(build-classpath objectweb-asm/asm-util) extlibs/asm-util-3.1.jar
# extlibs/constantine-0.4.jar.no
ln -s $(build-classpath constantine) extlibs/constantine-0.4.jar
# extlibs/cpptasks/cpptasks.jar.no
ln -s $(build-classpath cpptasks) extlibs/cpptasks.jar
# extlibs/jarjar-0.7.jar.no
ln -s $(build-classpath jarjar) extlibs/jarjar-0.7.jar
# extlibs/jline-0.9.95-SNAPSHOT.jar.no
ln -s $(build-classpath jline) extlibs/jline-0.9.95-SNAPSHOT.jar
# extlibs/jna.jar.no
ln -s $(build-classpath jna) extlibs/jna.jar
# extlibs/jna-posix.jar.no
ln -s $(build-classpath jna-posix) extlibs/jna-posix.jar
# extlibs/junit-3.8.2.jar.no
ln -s $(build-classpath junit) extlibs/junit-3.8.2.jar
# extlibs/libreadline-java-0.8.jar.no
ln -s /usr/lib/*java/libreadline-java.jar extlibs/libreadline-java-0.8.jar
# extlibs/mysql-connector-java-5.1.6.jar.no
ln -s $(build-classpath mysql-connector-java) extlibs/mysql-connector-java-5.1.6.jar
# extlibs/postgresql-8.3-603.jdbc4.jar.no
ln -s $(build-classpath postgresql-jdbc) extlibs/postgresql-8.3-603.jdbc4.jar
# extlibs/profile.jar.no
# extlibs/servlet-api-2.5.jar.no
ln -s $(build-classpath servlet_2_5_api) extlibs/servlet-api-2.5.jar
# extlibs/stringtemplate-3.2.jar.no
ln -s $(build-classpath stringtemplate) extlibs/stringtemplate-3.2.jar
# extlibs/svnant-jars/svnant.jar.no
# extlibs/svnant-jars/svnClientAdapter.jar.no
# extlibs/svnant-jars/svnjavahl.jar.no
# extlibs/xercesImpl-2.9.1.jar.no
ln -s $(build-classpath xerces-j2) extlibs/xercesImpl-2.9.1.jar


%build

ant17 developer-build javadoc jar-complete
pushd Doc
ht2html *.ht
popd

%install
rm -rf $RPM_BUILD_ROOT
# jar
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}
install -m 644 dist/%{name}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
install -m 644 dist/%{name}-dev.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-dev-%{version}.jar

(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}*; do ln -sf ${jar} ${jar/-%{version}/}; done)

%add_to_maven_depmap %{name} %{name} %{version} JPP %{name}
%add_to_maven_depmap org.python %{name} %{version} JPP %{name}

# poms
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
install -m 644 %{SOURCE1} \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}.pom

# manual
rm -f Doc/Makefile
rm -rf Doc/api
# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr dist/Doc/javadoc/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name}
# data
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/%{name}
ln -s %{_javadir}/%{name}.jar $RPM_BUILD_ROOT%{_datadir}/%{name}
ln -s %{_javadir}/%{name}-dev.jar $RPM_BUILD_ROOT%{_datadir}/%{name}
# these are not supposed to be distributed
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/%{name}/javalib
pushd $RPM_BUILD_ROOT%{_datadir}/%{name}/javalib
ln -s $(build-classpath antlr)
ln -s $(build-classpath antlr3)
ln -s $(build-classpath antlr3-runtime)
ln -s $(build-classpath objectweb-asm/asm)
ln -s $(build-classpath objectweb-asm/asm-commons)
ln -s $(build-classpath objectweb-asm/asm-util)
ln -s $(build-classpath constantine)
ln -s $(build-classpath cpptasks)
ln -s $(build-classpath jarjar)
ln -s $(build-classpath jline)
ln -s $(build-classpath jna)
ln -s $(build-classpath jna-posix)
ln -s $(build-classpath junit)
ln -s /usr/lib/*java/libreadline-java.jar
ln -s $(build-classpath mysql-connector-java)
ln -s $(build-classpath postgresql-jdbc)
ln -s $(build-classpath servlet_2_5_api)
ln -s $(build-classpath stringtemplate)
ln -s $(build-classpath xerces-j2)
popd
find dist/Lib -type d -name test | xargs rm -rf
cp -pr dist/Lib $RPM_BUILD_ROOT%{_datadir}/%{name}
#cp -pr dist/Tools $RPM_BUILD_ROOT%{_datadir}/%{name}
cp -pr Demo $RPM_BUILD_ROOT%{_datadir}/%{name}

# registry
install -m 644 registry $RPM_BUILD_ROOT%{_datadir}/%{name}
# scripts
install -d $RPM_BUILD_ROOT%{_bindir}

cat > $RPM_BUILD_ROOT%{_bindir}/%{name} << EOF
#!/bin/sh
#
# %{name} script
# JPackage Project (http://jpackage.sourceforge.net)

# Source functions library
. %{_datadir}/java-utils/java-functions

# Source system prefs
if [ -f %{_sysconfdir}/%{name}.conf ] ; then
  . %{_sysconfdir}/%{name}.conf
fi

# Source user prefs
if [ -f \$HOME/.%{name}rc ] ; then
  . \$HOME/.%{name}rc
fi

# Configuration
MAIN_CLASS=org.python.util.%{name}
BASE_FLAGS=-Dpython.home=%{_datadir}/%{name}
BASE_JARS="%{name} servlet_2_5_api"

if [ -f %{_libdir}/libJavaReadline.so ]; then
  BASE_FLAGS="\$BASE_FLAGS -Dpython.console=org.python.util.ReadlineConsole"
  BASE_FLAGS="\$BASE_FLAGS -Djava.library.path=%{_libdir}"
  BASE_FLAGS="\$BASE_FLAGS -Dpython.console.readlinelib=GnuReadline"
  BASE_JARS="\$BASE_JARS libreadline-java"
fi

if [ -f %{_javadir}/mysql-connector-java.jar ]; then
  BASE_JARS="\$BASE_JARS mysql-connector-java"
fi

# Set parameters
set_jvm
set_classpath \$BASE_JARS
set_flags \$BASE_FLAGS
set_options \$BASE_OPTIONS

# Let's start
run "\$@"
EOF

cat > $RPM_BUILD_ROOT%{_bindir}/%{name}c << EOF
#!/bin/sh
#
# %{name}c script
# JPackage Project (http://jpackage.sourceforge.net)

%{_bindir}/%{name} %{_datadir}/%{name}/Tools/%{name}c/%{name}c.py "\$@"
EOF

rm -f $RPM_BUILD_ROOT%{_datadir}/%{name}/Lib/UserDict.py

%if %{gcj_support}
export CLASSPATH=$(build-classpath gnu-crypto)
%{_bindir}/aot-compile-rpm --exclude %{_datadir}/%{name}/Demo/jreload
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap
%{_bindir}/%{name} <<EOT
EOT
%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%preun
rm -rf %{_datadir}/%{name}/cachedir

%postun
%update_maven_depmap
%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%files
%defattr(-,root,root)
%doc ACKNOWLEDGMENTS NEWS LICENSE.txt README.txt
%attr(0755,root,root) %{_bindir}/%{name}
%attr(0755,root,root) %{_bindir}/%{name}c
%{_javadir}/*
%dir %{_datadir}/%{name}
%{_datadir}/%{name}/*.jar
%{_datadir}/%{name}/javalib
%{_datadir}/%{name}/Lib
#%{_datadir}/%{name}/Tools
%{_datadir}/%{name}/registry
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}/*
%if %{gcj_support}
%dir %attr(-,root,root) %{_libdir}/gcj/%{name}
%attr(-,root,root) %{_libdir}/gcj/%{name}/%{name}-%{version}.jar.*
%endif

%files manual
%defattr(-,root,root)
%doc Doc/*.html Doc/images

%files javadoc
%defattr(-,root,root)
%{_javadocdir}/%{name}-%{version}
%ghost %{_javadocdir}/%{name}

%files demo
%defattr(-,root,root)
%{_datadir}/%{name}/Demo

%changelog
* Wed Nov 16 2011 Ralph Apel <r.apel at r-apel.de> - 0:2.5.0-1jpp
- Upgrade to 2.5.0

* Thu Jul 12 2007 Ralph Apel <r.apel at r-apel.de> - 0:2.2-0.rc2.1jpp
- Upgrade to 2.2-rc2

* Tue Feb 27 2007 Ralph Apel <r.apel at r-apel.de> - 0:2.2-0.a0.4jpp
- Add gcj_support option
- Assure optionality of mysql-connector-java
- Reactivate ht2html BR

* Tue Jun 20 2006 Ralph Apel <r.apel at r-apel.de> - 0:2.2-0.a0.3jpp
- First JPP-1.7 release
- Oracle JDBC not required, MySQL JDBC optional

* Sun Aug 23 2004 Randy Watler <rwatler at finali.com> - 0:2.2-0.a0.2jpp
- Rebuild with ant-1.6.2
- Allow build use of python >= 2.3 to generate docs since 2.2 libraries included

* Sun Feb 15 2004 David Walluck <david@anti-microsoft.org> 0:2.2-0.a0.1jpp
- 2.2a0 (CVS)
- add URL tag
- add Distribution tag
- change cachedir patch to use ~/.jython instead of ~/tmp
- remove sys.platform patch
- use included python 2.2 files
- mysql support is back

* Fri Apr 11 2003 David Walluck <david@anti-microsoft.org> 0:2.1-5jpp
- rebuild for JPackage 1.5
- remove mm.mysql support

* Sun Jan 26 2003 David Walluck <david@anti-microsoft.org> 2.1-4jpp
- add PyXML modules from 0.8.2
- make BuildRequires a bit more strict

* Wed Jan 22 2003 David Walluck <david@anti-microsoft.org> 2.1-3jpp
- CVS 20030122
- remove javacc dependency (it's non-free, not needed, and the build is broken)
- add python modules (BuildRequires: python)
- add PyXML modules (BuildRequires: PyXML)
- add HTML documentation (BuildRequires: ht2html)
- optional JavaReadline support (BuildRequires: libreadline-java)
- optional MySQL support (BuildRequires: mm.mysql)
- optional PostgreSQL support is not available at this time due to strange jars
- add jython script
- add jythonc script
- add registry
- Patch0: fix cachedir creation in cwd
- Patch1: fix sys.platform (site.py expects format: <os.name>-<os.arch>)
- remove oro class files from jython and require the oro RPM instead
- change Url tag

* Mon Mar 18 2002 Guillaume Rousse <guillomovitch@users.sourceforge.net> 2.1-2jpp 
- generic servlet support

* Wed Mar 06 2002 Guillaume Rousse <guillomovitch@users.sourceforge.net> 2.1-1jpp 
- 2.1
- section macro

* Thu Jan 17 2002 Guillaume Rousse <guillomovitch@users.sourceforge.net> 2.0-2jpp
- versioned dir for javadoc
- no dependencies for manual and javadoc packages
- stricter dependency for demo package

* Tue Dec 18 2001 Guillaume Rousse <guillomovitch@users.sourceforge.net> 2.0-1jpp
- first JPackage release
